/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SMS.h"
#include "Token.h"
#include "GaduThread.h"
#include "SMSConfig.h"

#include <stdio.h>
//#include "gifimage.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSMSForm *SMSForm;
extern AnsiString GGDir;
//---------------------------------------------------------------------------
__fastcall TSMSForm::TSMSForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
extern AnsiString GGDir;
//---------------------------------------------------------------------------
void __fastcall TSMSForm::Button1Click(TObject *Sender)
{
        if (Edit1 -> Text == "" || ComboBox1 -> ItemIndex == -1 || Memo1 -> Lines -> Text == "")
        {
                MessageBox (Handle, "Musisz wybrac siec, podac numer telefonu i wpisac tekst SMS-a\nprzed wyslaniem wiadomosci z bramki.", "Blad", MB_OK | MB_ICONERROR);
                return;
        }

        AnsiString server_addr, doc, host, Request, Fields, Reply, Tekst;
        char buf[1024];
        int count;

        char *temp = gg_urlencode (Memo1 -> Lines -> Text.c_str());
        Tekst = temp;
        free (temp);

        switch (ComboBox1->ItemIndex)
        {
                case 0:
                        server_addr = "213.218.116.131";
                        doc = "/sendsms.aspx";
                        host = "213.218.116.131";
                        // SMSLog -> Lines -> Add ("[SMS] Idea");
                        Fields = "SENDER=" + Edit3 -> Text + "&RECIPIENT=" + Edit1 -> Text + Edit2 -> Text + "&SHORT_MESSAGE=" + Tekst;
                break;

                case 1:
                        server_addr = "212.2.96.57";
                        doc = "/sms/sendsms.php";
                        host = "www.text.plusgsm.pl";
                        // SMSLog -> Lines -> Add ("[SMS] Plus GSM");
                        Fields="tprefix=" + Edit1 -> Text + "&numer=" + Edit2 -> Text + "&odkogo=" + Edit3 -> Text + "&tekst=" + Tekst;
                break;

                case 2:
                        server_addr = "";
                break;
        }

        TClientSocket *S;
        TWinSocketStream *SS;

        if (ComboBox1 -> ItemIndex == 0) // Additional IDEA-specific processing
        {
                S = new TClientSocket (NULL);
                S -> ClientType = ctBlocking;
                S -> Address = "213.218.116.131";
                S -> Port = 80;
                S -> Open();
                SS = new TWinSocketStream (S -> Socket, 5000);
                Request = "GET / HTTP/1.0\r\n\
Host: 213.218.116.131\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n\r\n";
                if (SMSConfigForm -> CheckBox1 -> Checked) SMSLog -> Lines -> Add (Request);
//                ShowMessage (Request.c_str());
//                ShowMessage (IntToStr (strlen (Request.c_str())));
                SS -> Write (Request.c_str(), Request.Length() + 1);
                Reply = "";
                while ((count = SS -> Read (buf, sizeof (buf))) > 0)
                {
                        // SMSLog -> Lines -> Add(buf);
                        Reply += ((AnsiString)buf).SubString (1, count);
                }
//                ShowMessage (Reply);
                delete SS;
                S -> Close();
                delete S;

                AnsiString Token;

                Token = Reply.SubString (Reply.Pos ("name=\"token\" value=\"") + 20, 36);
//                ShowMessage (Token);

                S = new TClientSocket (NULL);
                S -> ClientType = ctBlocking;
                S -> Port = 80;
                S -> Host = "213.218.116.131";
                S -> Open();

                SS = new TWinSocketStream (S -> Socket, 10000);

                Request = "GET /rotate_token.aspx?token=" + Token + " HTTP/1.0\r\n\
Host: 213.218.116.131\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n\
Pragma: no-cache\r\n\r\n";

                SS -> Write (Request.c_str(), Request.Length());

                char *big_buf = NULL;
                int big_buf_size = 0, pos, read;

                while ((read = SS -> Read (buf, sizeof(buf))) > 0)
                {
                        big_buf_size += read;
                        if (big_buf_size > 65535) break;
                        big_buf = (char*)realloc (big_buf, big_buf_size);
                        memcpy (big_buf + big_buf_size - read, buf, read);
                }

                pos = ((AnsiString)big_buf).Pos ("\r\n\r\n");

                FILE *f = fopen ((GGDir + "\\temp\\idea_token_pic.gif").c_str(), "wb");
                fwrite (big_buf + pos + 3, 1, big_buf_size - pos - 3, f);
                fclose (f);
                free (big_buf);

                delete SS;
                S -> Close();
                delete S;

//                TGIFImage *gif = new TGIFImage;
//                gif -> LoadFromFile (GGDir + "\\temp\\idea_token_pic.gif");
//                TokenForm -> Image1 -> Picture -> Assign (gif);
//                delete gif;

                // TokenForm -> WB -> Navigate (WideString("http://213.218.116.131/rotate_token.aspx?token=" + Token));
                TokenForm -> Edit1 -> Text = "";
                TokenForm -> ShowModal();
                Fields += "&token=" + Token + "&pass=" + TokenForm -> Edit1 -> Text;
        } else
        if (ComboBox1 -> ItemIndex == 2 || ComboBox1 -> ItemIndex == 3) // Additional ERA-specific processing
        {
                AnsiString Login, Password;

                if (ComboBox1 -> ItemIndex == 2)
                        Request = "GET /sms/do/extern/tinker/free/send?minute=&number=48"+ Edit1 -> Text + Edit2 -> Text + "&hour=&password=" + SMSConfigForm -> Edit2 -> Text + "&login=48" + SMSConfigForm -> Edit1 -> Text + "&message=" + Tekst + "&signature=" + Edit3 -> Text + "&success=http://oki_doki_wyszlo&contact=&failure=http://bleee_nie_wyszlo HTTP/1.0\r\n\
Host: www.eraomnix.pl\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n\r\n"; else
                        Request = "GET /sms/do/extern/tinker/multi/send?minute=&day=&success=http://oki_doki_wyszlo&password=" + SMSConfigForm -> Edit4 -> Text + "&login=48" + SMSConfigForm -> Edit3 -> Text+ "&alert=off&signature=" + Edit3 -> Text + "&ems=off&numbers=48" + Edit1 -> Text + Edit2 -> Text + "&contact=&smartBreaking=off&failure=http://bleee_nie_wyszlo&month=&hour=&asPhone=off&message=" + Tekst + "&status=off HTTP/1.0\r\n\
Host: www.eraomnix.pl\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n\r\n";

                if (SMSConfigForm -> CheckBox1 -> Checked) SMSLog -> Lines -> Add (Request);

                S = new TClientSocket (NULL);
                S -> ClientType = ctBlocking;
                S -> Host = "www.eraomnix.pl";
                S -> Port = 80;
                S -> Open();

                SS = new TWinSocketStream (S -> Socket, 10000);
                
                SS -> Write (Request.c_str(), Request.Length());

                Reply = "";
                while ( (count = SS -> Read (buf, sizeof(buf))) > 0 )
                        Reply += ((AnsiString)buf).SubString (1, count);

                if (SMSConfigForm -> CheckBox1 -> Checked) SMSLog -> Lines -> Add (Reply);

                delete SS;
                S -> Close();
                delete S;

                goto finito;
        }

        if (SMSConfigForm -> CheckBox1 -> Checked) SMSLog -> Lines -> Add ("[SMS] Server: " + server_addr + " Doc: " + doc);

        Request = "POST " + doc + " HTTP/1.0\r\n\
Host: " + host + "\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n\
Content-Type: application/x-www-form-urlencoded\r\n\
Content-Length: " + IntToStr(Fields.Length() + 1) + "\r\n\r\n" + Fields;

        if (SMSConfigForm -> CheckBox1 -> Checked) SMSLog -> Lines -> Add (Request);

        S = new TClientSocket(NULL);
        S -> ClientType = ctBlocking;
        S -> Address = server_addr;
        S -> Port = 80;
        S -> Open();

        SS = new TWinSocketStream (S -> Socket, 1000);

        SS -> Write (Request.c_str(), Request.Length() + 1);

        Reply = "";
        while ( (count = SS -> Read (buf, sizeof(buf))) > 0 )
                Reply += ((AnsiString)buf).SubString (1, count);

        if (SMSConfigForm -> CheckBox1 -> Checked) SMSLog -> Lines -> Add (Reply);

        delete SS;
        S -> Close();
        delete S;

finito:

        int p;
        switch (ComboBox1 -> ItemIndex)
        {
                case 0:
                        p = Reply.Pos ("<td class=\"center\"><div class=\"tytDuzy\">Twj SMS zosta wysany</div>");
                break;

                case 1:
                        p = Reply.Pos ("<title>Plus GSM - SMS zosta wysany!!!</title>");
                break;

                case 2:
                case 3:
                        p = Reply.Pos ("Location: http://oki_doki_wyszlo");
                break;
        }

        if (p > 0)
                MessageBox (Handle, "SMS zostal wyslany.", "Sukces", MB_OK | MB_ICONINFORMATION);
        else
                MessageBox (Handle, "SMS nie zostal wyslany.", "Blad", MB_OK | MB_ICONERROR);

        AnsiString a;
        a = Edit1 -> Text + Edit2 -> Text;
        if (!DirectoryExists (log_file + "\\" + a)) CreateDir (log_file + "\\" + a); 
        FILE *f = fopen ((log_file + "\\" + a + "\\" + IntToStr(time(NULL)) + ".txt").c_str(), "w");
        fputs (Memo1 -> Lines -> Text.c_str(), f);
        fclose (f);
}
//---------------------------------------------------------------------------
void __fastcall TSMSForm::FormCreate(TObject *Sender)
{
        log_file += GGDir + "\\sms";

        Height = 260;
}
//---------------------------------------------------------------------------

void __fastcall TSMSForm::Button2Click(TObject *Sender)
{
        Button2 -> Tag = !Button2 -> Tag;
        if (Button2 -> Tag)
        {
                Height = 380;
                Button2 -> Caption = "<<";
        } else
        {
                Height= 260;
                Button2 -> Caption = ">>";
        }
}
//---------------------------------------------------------------------------
void __fastcall TSMSForm::ComboBox1DrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
        TCanvas *C = ((TComboBox*)Control)->Canvas;
        C -> FillRect (Rect);
        IL -> Draw (C, Rect.Left + 3, Rect.Top, Index, true);
        C -> TextOut (Rect.Left + 23, Rect.Top + 1, ((TComboBox*)Control) -> Items -> Strings[Index]);        
}
//---------------------------------------------------------------------------

void __fastcall TSMSForm::Button4Click(TObject *Sender)
{
        SMSConfigForm -> ShowModal();        
}
//---------------------------------------------------------------------------

void __fastcall TSMSForm::Button3Click(TObject *Sender)
{
        Close();        
}
//---------------------------------------------------------------------------

